##!/usr/bin/Rscript
par(ask=T)
##  !
##
##    
## 
##   R  
##
## 1.   R:
## !

##      6  : 
##  logical, integer, real, complex, string (or character),  raw

## ,         .  
## ,    ?
## 1. 
2 + 3
2 - 3
2 * 3
2 / 3
2 ^ 3 ##  2**3 
2:10
(2:10)[5]
(2:10)[5:7]
##      :
4 + 2*2^3 - 10
2-2:5
2^2:5
help("Syntax")

##   ,  
4 + 2*2^3 - 10
((4 + 2)*2)^3 - 10

## .    . 
##  - :
x = 10
##   :
y = 4*x + x^3 - 10*2

## 
##    , , f(x) = x^3 :
function(x) x^3
##  :
y = function(x) x^3
##  ,  :
y(10)
x = -10:10
plot(x, y(x))
##        :
y = function(x, a=100) x^3 - a
plot(x, y(a=10**3, x=x), type="l")
##     
c(1,2,3,4,5,6,10)
sum(x)
length(x)
log(x, 10)
log10(x)
sqrt(x)
x^(1/2)
abs(x)
print(x)

##  -  
data = rnorm(1000, mean = -10, sd = 5)
hist(data)

data.mean = sum(data)/length(data)
print(data.mean)

data.sd = sqrt(sum((data - data.mean)^2)/(length(data) - 1))
print(data.sd)

##  
mean(data)
sd(data)
##     
hist((data - mean(data))/sd(data))

##  "" , -      
##           _
##          |   a = x**2;
## F(x) =   {
##          |_  b = a * 5;
##           
             
f = function(x) {
    a = x**2
    b = a * 5
    b
}

f(10)

##   :
## 1    (   copy/pastle )

normalize <- function(d){            # d -  
    m  = mean(d)                     # m -  
    s  = sd(d)                       # s -   
    (d - m)/s                        
}
normalize(data)
normalize(1:10)

##   :
scale(1:10)

##   :
## 2   *apply
sapply(1:5, function(i) 1/i )

n = 100
sampleMean = sapply( 1:(length(data)/n), function(i) {
    start = n * ( i - 1 )
    end   = n * i
    mean(data[start:end])
})
hist(sampleMean)

start <-  c(5, 100, 300)
end <- start + 100
mapply(function(start, end) {
    mean(data[start:end])
},  start, end)


